//+------------------------------------------------------------------+
//|                                     One more average heiken ashi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Orange
#property indicator_color2 LimeGreen
#property indicator_color3 Orange
#property indicator_color4 LimeGreen
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int    OmaPeriod       = 20;
extern double OmaSpeed        = 3.0;
extern bool   OmaAdaptive     = true;
extern bool   BetterFormula   = true;
extern double Step            = 0;
extern bool   DrawClassical   = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
//
//
//
//
//

double ExtMapBufferc1[];
double ExtMapBufferc2[];
double ExtMapBufferc3[];
double ExtMapBufferc4[];
double trend[];
double trenb[];
double stored[][28];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, ExtMapBufferc1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBufferc2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBufferc3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBufferc4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, trend);
   SetIndexBuffer(5, trenb);
   IndicatorShortName("One more average Heiken Ashi("+OmaPeriod+","+DoubleToStr(OmaSpeed,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
int start()
{
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haClose, haLow, haHigh;
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);
         if (ArrayRange(ExtMapBuffer1,0) != Bars) ArrayResize(ExtMapBuffer1,Bars);
         if (ArrayRange(ExtMapBuffer2,0) != Bars) ArrayResize(ExtMapBuffer2,Bars);
         if (ArrayRange(ExtMapBuffer3,0) != Bars) ArrayResize(ExtMapBuffer3,Bars);
         if (ArrayRange(ExtMapBuffer4,0) != Bars) ArrayResize(ExtMapBuffer4,Bars);
         if (Digits==3 || Digits==5)
               double pointModifier = 10;
         else         pointModifier = 1;               

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      maOpen  = iAverage(Open[i] ,OmaPeriod,OmaSpeed,OmaAdaptive,r, 0);
      maClose = iAverage(Close[i],OmaPeriod,OmaSpeed,OmaAdaptive,r, 7);
      maLow   = iAverage(Low[i]  ,OmaPeriod,OmaSpeed,OmaAdaptive,r,14);
      maHigh  = iAverage(High[i] ,OmaPeriod,OmaSpeed,OmaAdaptive,r,21);
   
      //
      //
      //
      //
      //
        
         if (BetterFormula) {
               if (maHigh!=maLow)
                     haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose = (maOpen+maClose)/2; }
         else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                     haOpen   = (ExtMapBuffer3[r-1]+ExtMapBuffer4[r-1])/2;
                     haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { ExtMapBuffer1[r]=haLow;  ExtMapBuffer2[r]=haHigh; } 
         else                { ExtMapBuffer1[r]=haHigh; ExtMapBuffer2[r]=haLow;  } 
                               ExtMapBuffer3[r]=haOpen;
                               ExtMapBuffer4[r]=haClose;
   
      //
      //
      //
      //
      //
        
      if (Step>0)
      {
         if( MathAbs(ExtMapBuffer1[r]-ExtMapBuffer1[r-1]) < Step*pointModifier*Point ) ExtMapBuffer1[r]=ExtMapBuffer1[r-1];
         if( MathAbs(ExtMapBuffer2[r]-ExtMapBuffer2[r-1]) < Step*pointModifier*Point ) ExtMapBuffer2[r]=ExtMapBuffer2[r-1];
         if( MathAbs(ExtMapBuffer3[r]-ExtMapBuffer3[r-1]) < Step*pointModifier*Point ) ExtMapBuffer3[r]=ExtMapBuffer3[r-1];
         if( MathAbs(ExtMapBuffer4[r]-ExtMapBuffer4[r-1]) < Step*pointModifier*Point ) ExtMapBuffer4[r]=ExtMapBuffer4[r-1];
      }         
      trend[i] = trend[i+1];
      trenb[i] = trenb[i+1];
      if (ExtMapBuffer1[r]>ExtMapBuffer2[r]) trend[i] = -1;
      if (ExtMapBuffer1[r]<ExtMapBuffer2[r]) trend[i] =  1;
      if (ExtMapBuffer3[r]>ExtMapBuffer4[r]) trenb[i] = -1;
      if (ExtMapBuffer3[r]<ExtMapBuffer4[r]) trenb[i] =  1;
      if (DrawClassical)
      {
         ExtMapBufferc1[i] = ExtMapBuffer1[r];
         ExtMapBufferc2[i] = ExtMapBuffer2[r];
         ExtMapBufferc3[i] = ExtMapBuffer3[r];
         ExtMapBufferc4[i] = ExtMapBuffer4[r];
      }
      else
      {
            if (trend[i]== 1) { ExtMapBufferc2[i]=High[i]; ExtMapBufferc1[i]=Low[i]; }
            if (trend[i]==-1) { ExtMapBufferc1[i]=High[i]; ExtMapBufferc2[i]=Low[i]; }
            if (trenb[i]== 1) { ExtMapBufferc4[i]=MathMax(Open[i],Close[i]); ExtMapBufferc3[i]=MathMin(Open[i],Close[i]); }
            if (trenb[i]==-1) { ExtMapBufferc4[i]=MathMin(Open[i],Close[i]); ExtMapBufferc3[i]=MathMax(Open[i],Close[i]); }
      }
   }  
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," OMA heiken ashi trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"OMA heiken ashi "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

